#include <iostream>

#include "complwindow.h"

ComplWindow::ComplWindow(BaseObjectType* cobject, Glib::RefPtr<Gnome::Glade::Xml> xml)
:	Gtk::Window(cobject),
	m_ref_glade(xml),
	m_name_entry(dynamic_cast<Gtk::Entry*>(m_ref_glade->get_widget("name_entry"))),
	m_surname_entry(dynamic_cast<Gtk::Entry*>(m_ref_glade->get_widget("surname_entry"))),
	m_ref_name_compl(Gtk::EntryCompletion::create()),
	m_ref_surname_compl(Gtk::EntryCompletion::create()),
	m_model_columns(),
	m_ref_tree_model(Gtk::ListStore::create(m_model_columns))
{
	Gtk::TreeModel::Row data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 1;
	data_row[m_model_columns.m_name] = Glib::ustring("Bram");
	data_row[m_model_columns.m_surname] = Glib::ustring("Stoker");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 2;
	data_row[m_model_columns.m_name] = Glib::ustring("Robert");
	data_row[m_model_columns.m_surname] = Glib::ustring("Jordan");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 3;
	data_row[m_model_columns.m_name] = Glib::ustring("Arturo");
	data_row[m_model_columns.m_surname] = Glib::ustring("Perez-Reverte");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 4;
	data_row[m_model_columns.m_name] = Glib::ustring("Andrzej");
	data_row[m_model_columns.m_surname] = Glib::ustring("Sapkowski");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 5;
	data_row[m_model_columns.m_name] = Glib::ustring("Anthony");
	data_row[m_model_columns.m_surname] = Glib::ustring("Burgess");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 6;
	data_row[m_model_columns.m_name] = Glib::ustring("Isaac");
	data_row[m_model_columns.m_surname] = Glib::ustring("Asimov");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 7;
	data_row[m_model_columns.m_name] = Glib::ustring("Jules");
	data_row[m_model_columns.m_surname] = Glib::ustring("Verne");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 8;
	data_row[m_model_columns.m_name] = Glib::ustring("Mark");
	data_row[m_model_columns.m_surname] = Glib::ustring("Twain");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 9;
	data_row[m_model_columns.m_name] = Glib::ustring("Douglas");
	data_row[m_model_columns.m_surname] = Glib::ustring("Adams");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 10;
	data_row[m_model_columns.m_name] = Glib::ustring("Neil");
	data_row[m_model_columns.m_surname] = Glib::ustring("Gaiman");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 11;
	data_row[m_model_columns.m_name] = Glib::ustring("Gabriel");
	data_row[m_model_columns.m_surname] = Glib::ustring("Garcia Marquez");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 12;
	data_row[m_model_columns.m_name] = Glib::ustring("Umberto");
	data_row[m_model_columns.m_surname] = Glib::ustring("Eco");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 13;
	data_row[m_model_columns.m_name] = Glib::ustring("Haruki");
	data_row[m_model_columns.m_surname] = Glib::ustring("Murakami");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 14;
	data_row[m_model_columns.m_name] = Glib::ustring("Thomas");
	data_row[m_model_columns.m_surname] = Glib::ustring("Mann");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 15;
	data_row[m_model_columns.m_name] = Glib::ustring("Terry");
	data_row[m_model_columns.m_surname] = Glib::ustring("Pratchett");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 16;
	data_row[m_model_columns.m_name] = Glib::ustring("Julio");
	data_row[m_model_columns.m_surname] = Glib::ustring("Cortazar");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 17;
	data_row[m_model_columns.m_name] = Glib::ustring("Mario");
	data_row[m_model_columns.m_surname] = Glib::ustring("Puzo");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 18;
	data_row[m_model_columns.m_name] = Glib::ustring("Susan");
	data_row[m_model_columns.m_surname] = Glib::ustring("Donnell");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 19;
	data_row[m_model_columns.m_name] = Glib::ustring("Wojciech");
	data_row[m_model_columns.m_surname] = Glib::ustring("Cejrowski");
	data_row = *(m_ref_tree_model->append());
	data_row[m_model_columns.m_id] = 20;
	data_row[m_model_columns.m_name] = Glib::ustring("Aleksander");
	data_row[m_model_columns.m_surname] = Glib::ustring("Dumas");
	m_ref_name_compl->set_model(m_ref_tree_model);
	m_ref_surname_compl->set_model(m_ref_tree_model);
	m_ref_name_compl->set_text_column(m_model_columns.m_name);
	m_ref_surname_compl->set_text_column(m_model_columns.m_surname);
	m_name_entry->set_completion(m_ref_name_compl);
	Glib::RefPtr<Gtk::EntryCompletion> m_ref_compl(m_name_entry->get_completion());
	m_surname_entry->set_completion(m_ref_surname_compl);
	m_ref_name_compl->signal_match_selected().connect(sigc::mem_fun(*this, &ComplWindow::on_match_selected));
}

ComplWindow::~ComplWindow()
{}

bool
ComplWindow::on_match_selected(const Gtk::TreeModel::iterator& iter)
{
	Glib::ustring name((*iter)[m_model_columns.m_name]);
	Glib::ustring surname((*iter)[m_model_columns.m_surname]);
	std::cout << name << " " << surname << std::endl;
	m_name_entry->set_text(name);
	m_surname_entry->set_text(surname);
	return true;
}
