#ifndef _COMPL_WINDOW_H_
#define _COMPL_WINDOW_H_

#include <gtkmm.h>
#include <libglademm.h>

class ComplWindow : public Gtk::Window
{
	public:
		ComplWindow(BaseObjectType* cobject, Glib::RefPtr<Gnome::Glade::Xml> xml);
		~ComplWindow();
	protected:
		virtual bool on_match_selected(const Gtk::TreeModel::iterator& iter);
	private:
		class ModelColumns : public Gtk::TreeModel::ColumnRecord
		{
			public:
				ModelColumns()
				{
					add(m_id);
					add(m_name);
					add(m_surname);
				}
				Gtk::TreeModelColumn<int> m_id;
				Gtk::TreeModelColumn<Glib::ustring> m_name;
				Gtk::TreeModelColumn<Glib::ustring> m_surname;
				
		};
		Glib::RefPtr<Gnome::Glade::Xml> m_ref_glade;
		Gtk::Entry* m_name_entry;
		Gtk::Entry* m_surname_entry;
		Glib::RefPtr<Gtk::EntryCompletion> m_ref_name_compl;
		Glib::RefPtr<Gtk::EntryCompletion> m_ref_surname_compl;
		ModelColumns m_model_columns;
		Glib::RefPtr<Gtk::ListStore> m_ref_tree_model;
};

#endif // _COMPL_WINDOW_H_
